*  ͻ  *
*   T3-Net1:     T3RETRY (c) 1987 TECH III, INC. All rights reserved.      *
*  ͼ  *

** <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> **
**																																					 **
**  Network file opening & resource sharing program                         **
**  Called by T3FOPEN and T3RECLOC and T3ADDREC                             **
**                                                                          **
**  This is a proprietary Tech III product that may have                    **
**  been modified for use in this application.                              **
**                                                                          **
**  You may acquire the right to compile and include these utilities as     **
**  part of an unlimited number of larger applications by paying a license  **
**  fee of  $ 95.00 to Tech III.  You may not resell or publish this utility**
**  as part of a set of utilities or in competition with Tech III.  These   **
**  utilities may be distributed for evaluation at no charge or on a disk   **
**  that is sold for no more than $ 5.00.                                   **
**                                                                          **
**  Simple as they may seem, these utilities took quite a bit of blood,     **
**  sweat, and tears to develop.  Go ahead and share them for evaluation,   **
**  learning, etc, but please keep these headers intact, and if you like    **
**  the utilities, support us in doing more of this by paying for them.     **
**                                                                          **
**  You can reach Tech III at: 255 W. 5th St. // San Pedro, CA   90731      **
**  You can pay by credit card (AE,MC,V): 800-543-9941 outside California   **
**                                        213-547-2191 inside  California   **
**                                                                          **
** <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> **

parameters ERR_MSG
* ERR_MSG    = Message to display.

private COUNTER  && Will use a few lines down from here.

* If we've already retried 10 times, we give up:  the GLOBAL variable SUCCESS
* is used throughout the networking utilities to indicate the success or
* failure of any operation.
if ATTEMPTS > 10
  store .f. to SUCCESS
  return
endif

* Display error message followed by increasing number of dots as retrying
* continues - looks nice and is informative for the user.
@ 23,00 say ERR_MSG
@ 24,00 say "                         "
@ 24,00 say "Trying again" + replicate(".", RETRYCOUNT)

* We want to prevent RESOURCE HOGGING & DEADLY EMBRACE, a situation that
* can occur if we were to execute retries at high speed inside a DO loop.
* So we only retry once per second.  As an additional safety measure in
* case the system clock is screwy, we also place a limit of 250 "beats"
* of the counter, as the maximum wait time.

store 0 to COUNTER
store time() to LAST_TIME
do while substr(time(),7,2) = substr(LAST_TIME,7,2) .and. COUNTER < 250
  store COUNTER + 1 to COUNTER
enddo
* ATTEMPTS   = How many times the calling program has called retried already.
store ATTEMPTS + 1 to ATTEMPT
retry
return
* eof
